﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using Alchemy;
using Alchemy.Classes;

namespace AlchemyWebSocketTest
{
    class Program
    {
        private static List<UserContext> sockets = new List<UserContext>();
        static void Main(string[] args)
        {
            // instantiate a new server - acceptable port and IP range,
            // and set up your methods.

            var aServer = new WebSocketServer(81, IPAddress.Any)
            {
                OnReceive = OnReceive,
                OnSend = OnSend,
                OnConnect = OnConnect,
                OnConnected = OnConnected,
                OnDisconnect = OnDisconnect,
                TimeOut = new TimeSpan(0, 5, 0)
            };

            aServer.Start();
            string consoleReadLine;
            do
            {
                consoleReadLine = Console.ReadLine();
                sockets.ForEach(s => s.Send(consoleReadLine));
            } while (consoleReadLine != "exit");
        }

        private static void OnReceive(UserContext context)
        {
            Console.WriteLine("Client " + context.ClientAddress.ToString() + " sended: " + context.DataFrame.ToString());
        }

        private static void OnSend(UserContext context)
        {
            Console.WriteLine("Sended to client "+context.ClientAddress+": " + context.DataFrame);
        }

        private static void OnConnect(UserContext context)
        {
            Console.WriteLine("Client connecting From : " + context.ClientAddress.ToString());
        }

        static void OnConnected(UserContext context)
        {
            sockets.Add(context);
            Console.WriteLine("Client Connection From : " + context.ClientAddress.ToString());
        }

        static void OnDisconnect(UserContext context)
        {
            Console.WriteLine("Client disconneted From : " + context.ClientAddress.ToString());
        }
    }
}
