using System.Web;
using XSockets.Core.Common.Socket;
using XSockets.Server;

[assembly: PreApplicationStartMethod(typeof(XSocketsTest.App_Start.XSocketsBootstrap), "Start")]

namespace XSocketsTest.App_Start
{
    public static class XSocketsBootstrap
    {
        public static IXBaseServerContainer wss;
        public static XBaseSocketServer server;
        public static void Start()
        {
            wss = XSockets.Plugin.Framework.Composable.GetExport<IXBaseServerContainer>();
            
            wss.OnHandshakeCompleted += wss_OnHandshakeCompleted;
            wss.OnServerClientConnection += wss_OnServerClientConnection;
            wss.OnServerClientDisconnection += wss_OnServerClientDisconnection;
            wss.OnServersStarted += wss_OnServersStarted;
            wss.OnServersStopped += wss_OnServersStopped;
            wss.OnHandshakeInvalid += wss_OnHandshakeInvalid;
            wss.OnError += wss_OnError;

            wss.StartServers();
        }

        static void wss_OnError(object sender, XSockets.Core.Common.Socket.Event.Arguments.OnErrorArgs e)
        {
            
        }

        static void wss_OnHandshakeInvalid(object sender, XSockets.Core.Common.Socket.Event.Arguments.OnHandshakeInvalidArgs e)
        {
            
        }

        static void wss_OnServersStopped(object sender, System.EventArgs e)
        {
            
        }

        static void wss_OnServersStarted(object sender, System.EventArgs e)
        {
            
        }

        static void wss_OnServerClientDisconnection(object sender, XSockets.Core.Common.Socket.Event.Arguments.OnClientDisConnectArgs e)
        {
            
        }

        static void wss_OnServerClientConnection(object sender, XSockets.Core.Common.Socket.Event.Arguments.OnClientConnectArgs e)
        {
            
        }

        static void wss_OnHandshakeCompleted(object sender, XSockets.Core.Common.Socket.Event.Arguments.OnHandshakeCompleteArgs e)
        {
            
        }        
    }
}