﻿using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using XSockets.Core.Common.Socket;

namespace XSocketsTestMVC
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication
    {
        public MvcApplication()
        {
        }
        public static void RegisterGlobalFilters(GlobalFilterCollection filters)
        {
            filters.Add(new HandleErrorAttribute());
        }

        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                "Default", // Route name
                "{controller}/{action}/{id}", // URL with parameters
                new { controller = "Home", action = "Index", id = UrlParameter.Optional } // Parameter defaults
            );

        }

        protected void Application_Init()
        {
            var wss = XSockets.Plugin.Framework.Composable.GetExport<IXBaseServerContainer>();
            wss.OnHandshakeCompleted += wss_OnHandshakeCompleted;
            wss.OnServerClientConnection += wss_OnServerClientConnection;
            wss.OnServerClientDisconnection += wss_OnServerClientDisconnection;
            wss.OnServersStarted += wss_OnServersStarted;
            wss.OnServersStopped += wss_OnServersStopped;
            wss.OnHandshakeInvalid += wss_OnHandshakeInvalid;
            wss.StartServers();

        }

        protected void Application_Start()
        {
            AreaRegistration.RegisterAllAreas();

            // Use LocalDB for Entity Framework by default
            Database.DefaultConnectionFactory = new SqlConnectionFactory(@"Data Source=(localdb)\v11.0; Integrated Security=True; MultipleActiveResultSets=True");

            RegisterGlobalFilters(GlobalFilters.Filters);
            RegisterRoutes(RouteTable.Routes);

           
        }

        static void wss_OnError(object sender, XSockets.Core.Common.Socket.Event.Arguments.OnErrorArgs e)
        {

        }

        static void wss_OnHandshakeInvalid(object sender, XSockets.Core.Common.Socket.Event.Arguments.OnHandshakeInvalidArgs e)
        {

        }

        static void wss_OnServersStopped(object sender, System.EventArgs e)
        {

        }

        static void wss_OnServersStarted(object sender, System.EventArgs e)
        {

        }

        static void wss_OnServerClientDisconnection(object sender, XSockets.Core.Common.Socket.Event.Arguments.OnClientDisConnectArgs e)
        {

        }

        static void wss_OnServerClientConnection(object sender, XSockets.Core.Common.Socket.Event.Arguments.OnClientConnectArgs e)
        {

        }

        static void wss_OnHandshakeCompleted(object sender, XSockets.Core.Common.Socket.Event.Arguments.OnHandshakeCompleteArgs e)
        {

        }        
    }
}